// TestLnKLibDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TestLnKLib.h"
#include "TestLnKLibDlg.h"
#include "LnKSLIMbusAnalyzer_TG_IF.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



char * errortxt[] = 
{
"LNK_SLIMBUS_OK",
"LNK_SLIMBUS_ANALYZER_NOT_FOUND",
"LNK_SLIMBUS_ACTION_NOT_ALLOWED",
"LNK_SLIMBUS_FILE_WRITE_ERROR",
"LNK_SLIMBUS_FILE_READ_ERROR",
"LNK_SLIMBUS_FORMAT_TYPE_ERROR",
"LNK_SLIMBUS_XML_TRANSLATION_ERROR",
"LNK_SLIMBUS_HARDWARE_NOT_CONNECTED",
"LNK_SLIMBUS_COMMAND_BUSY",
"LNK_SLIMBUS_INVALID_VALUE",
"LNK_SLIMBUS_NO_BUS_ACTIVITY_SEEN",
"LNK_SLIMBUS_ERROR_LAST"

};



/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestLnKLibDlg dialog

CTestLnKLibDlg::CTestLnKLibDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestLnKLibDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTestLnKLibDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTestLnKLibDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTestLnKLibDlg)
	DDX_Control(pDX, IDC_EDIT_MSG_LA, m_MsgLA);
	DDX_Control(pDX, IDC_EDIT_DATA_CHAN, m_ExpDataChan);
	DDX_Control(pDX, IDC_EDIT_SAVEAS, m_SaveAs);
	DDX_Control(pDX, IDC_BH, m_BusHold);
	DDX_Control(pDX, IDC_EDIT_OPEN_SBA, m_OpenSba);
	DDX_Control(pDX, IDC_EDIT_MSG_TO, m_MsgTo);
	DDX_Control(pDX, IDC_EDIT_MSG_FROM, m_MsgFrom);
	DDX_Control(pDX, IDC_EDIT_MSG_FILENAME, m_MsgFilename);
	DDX_Control(pDX, IDC_EDIT_DATA_TO, m_DataTo);
	DDX_Control(pDX, IDC_EDIT_DATA_FROM, m_DataFrom);
	DDX_Control(pDX, IDC_EDIT_DATA_FILENAME, m_DataFilename);
	DDX_Control(pDX, IDC_CHECK_MSG_INCLUDE_FRAMING_INFO, m_MsgFramingInfo);
	DDX_Control(pDX, IDC_CHECK_DATA_RAW, m_ExpDataRaw);
	DDX_Control(pDX, IDC_EDIT_RAW_FILENAME, m_RawFilename);
	DDX_Control(pDX, IDC_POLLMSGCNTR, m_PollMsgCntr);
	DDX_Control(pDX, IDC_POLL_MSG, m_PollMsg);
	DDX_Control(pDX, IDC_EDIT_RAW_TO, m_EditRawTo);
	DDX_Control(pDX, IDC_EDIT_RAW_FROM, m_EditRawFrom);
	DDX_Control(pDX, IDC_SB_33, m_sb_33);
	DDX_Control(pDX, IDC_IO_33, m_io_33);
	DDX_Control(pDX, IDC_CHECK_RAW_INCLUDE_FRAMING_INFO, m_exp_raw_incl_framing);
	DDX_Control(pDX, IDC_VCD_DATA, m_VCD_DataLabel);
	DDX_Control(pDX, IDC_VCD_CLOCK, m_VCD_ClockLabel);
	DDX_Control(pDX, IDC_EDIT5, m_LoadXML);
	DDX_Control(pDX, IDC_EDIT4, m_LoadTG);
	DDX_Control(pDX, IDC_EDIT3, m_ImportVCD);
	DDX_Control(pDX, IDC_LOG, m_log);
	//}}AFX_DATA_MAP
	//  DDX_Text(pDX, IDC_EXPORT_DATA_CHANNEL, m_ExportDataCh);
	//  DDX_Text(pDX, IDC_GET_DATA_CHANNEL, m_GetDataCh);
	DDX_Control(pDX, IDC_EXPORT_DATA_CHANNEL, m_ExportDataCh);
	DDX_Control(pDX, IDC_GET_DATA_CHANNEL, m_GetDataCh);
}

BEGIN_MESSAGE_MAP(CTestLnKLibDlg, CDialog)
	//{{AFX_MSG_MAP(CTestLnKLibDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnClose)
	ON_BN_CLICKED(IDC_BUTTON3, OnGetSwVersion)
	ON_BN_CLICKED(IDC_BUTTON4, OnGetDLLVersion)
	ON_BN_CLICKED(IDC_BUTTON5, OnGetConfig)
	ON_BN_CLICKED(IDC_BUTTON6, OnGetSN)
	ON_BN_CLICKED(IDC_BUTTON7, OnGetHWid)
	ON_BN_CLICKED(IDC_BUTTON8, OnStartFullRec)
	ON_BN_CLICKED(IDC_BUTTON9, OnStopFullRec)
	ON_BN_CLICKED(IDC_BUTTON10, OnStartMsgRec)
	ON_BN_CLICKED(IDC_BUTTON11, OnStopMsgRec)
	ON_BN_CLICKED(IDC_BUTTON12, OnPollLiveMsgCntr)
	ON_BN_CLICKED(IDC_BUTTON13, OnGetLiveMsg)
	ON_BN_CLICKED(IDC_BUTTON14, OnOpenSBA)
	ON_BN_CLICKED(IDC_BUTTON15, OnSaveSBAas)
	ON_BN_CLICKED(IDC_BUTTON16, OnImportVCD)
	ON_BN_CLICKED(IDC_BUTTON17, OnExportRAW)
	ON_BN_CLICKED(IDC_BUTTON18, OnExportData)
	ON_BN_CLICKED(IDC_BUTTON19, OnExportMsg)
	ON_BN_CLICKED(IDC_BUTTON20, OnLoadTG)
	ON_BN_CLICKED(IDC_BUTTON21, OnLoadXML)
	ON_BN_CLICKED(IDC_BUTTON22, OnTGPlay)
	ON_BN_CLICKED(IDC_BUTTON23, OnTGStop)
	ON_BN_CLICKED(IDC_BUTTON24, OnHWConfig)
	ON_BN_CLICKED(IDC_BUTTON25, OnIsConnected)
	ON_BN_CLICKED(IDC_BUTTON26, OnGetHWConfig)
	ON_BN_CLICKED(IDC_BUTTON27, OnGetBusState)
	ON_BN_CLICKED(IDC_BUTTON28, OnGetActionStatus)
	ON_BN_CLICKED(IDC_BUTTON29, Ondebugjk)
	ON_BN_CLICKED(IDC_BUTTON_RESET_HW, OnButtonResetHw)
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON_GET_NR_DATA_CH, &CTestLnKLibDlg::OnBnClickedButtonGetNrDataCh)
	ON_BN_CLICKED(IDC_BUTTON_EXPORT_ALL_DATA_HISTORY, &CTestLnKLibDlg::OnBnClickedButtonExportAllDataHistory)
	ON_BN_CLICKED(IDC_BUTTON_EXPORT_DATA_HISTORY, &CTestLnKLibDlg::OnBnClickedButtonExportDataHistory)
	ON_BN_CLICKED(IDC_BUTTON_GET_ALL_DATA_HISTORY, &CTestLnKLibDlg::OnBnClickedButtonGetAllDataHistory)
	ON_BN_CLICKED(IDC_BUTTON_GET_DATA_HISTORY, &CTestLnKLibDlg::OnBnClickedButtonGetDataHistory)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestLnKLibDlg message handlers

BOOL CTestLnKLibDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}






	m_OpenSba.SetWindowText("C:\\sba\\1.sba");
	m_SaveAs.SetWindowText("C:\\sba\\tmp\\1.sba");
	m_ImportVCD.SetWindowText("C:\\sba\\1.vcd");
	m_LoadTG.SetWindowText("C:\\sba\\1.tg");
	m_LoadXML.SetWindowText("C:\\sba\\1.xml");

	m_RawFilename.SetWindowText("C:\\sba\\__export_RAW.txt");
	m_DataFilename.SetWindowText("C:\\sba\\__export_Data.txt");
	m_MsgFilename.SetWindowText("C:\\sba\\__export_Msg.html");

	m_MsgLA.SetWindowText("0");

	m_VCD_DataLabel.SetWindowText("data");
	m_VCD_ClockLabel.SetWindowText("clock");

	m_sb_33.SetCheck(BST_CHECKED);
	m_io_33.SetCheck(BST_CHECKED);
	m_BusHold.SetCheck(BST_CHECKED);


	m_MsgFramingInfo.SetCheck(BST_CHECKED);
	m_exp_raw_incl_framing.SetCheck(BST_CHECKED);

	m_ExpDataRaw.SetCheck(BST_CHECKED);     //BST_UNCHECKED);

	pm_ExpRawFrom		= (CButton*) GetDlgItem(IDC_R_RAW_FROM);
	pm_ExpRawAll		= (CButton*) GetDlgItem(IDC_R_RAW_ALL);
	pm_ExpMsgFrom		= (CButton*) GetDlgItem(IDC_R_MSG_FROM);
	pm_ExpMsgAll		= (CButton*) GetDlgItem(IDC_R_MSG_ALL);
	pm_ExpDataFrom		= (CButton*) GetDlgItem(IDC_R_DATA_FROM);
	pm_ExpDataAll		= (CButton*) GetDlgItem(IDC_R_DATA_ALL);


	pm_ExpDataTxt		= (CButton*) GetDlgItem(IDC_DATA_TXT);
	pm_ExpDataHtml		= (CButton*) GetDlgItem(IDC_DATA_HTML);
	pm_ExpRawTxt		= (CButton*) GetDlgItem(IDC_RAW_TXT);
	pm_ExpRawHtml		= (CButton*) GetDlgItem(IDC_RAW_HTML);
	pm_ExpMsgTxt		= (CButton*) GetDlgItem(IDC_MSG_TXT);
	pm_ExpMsgHtml		= (CButton*) GetDlgItem(IDC_MSG_HTML);
	pm_ExpMsgRaw		= (CButton*) GetDlgItem(IDC_MSG_RAW);
	pm_ExpMsgDetailed	= (CButton*) GetDlgItem(IDC_MSG_DETAIL);
	pm_ExpMsgSynthetic	= (CButton*) GetDlgItem(IDC_MSG_SYN);
	pm_ExpMsgCSV		= (CButton*) GetDlgItem(IDC_MSG_CSV);


	pm_ExpRawAll->SetCheck(BST_CHECKED);
	pm_ExpMsgAll->SetCheck(BST_CHECKED);
	pm_ExpDataAll->SetCheck(BST_CHECKED);
	pm_ExpRawTxt->SetCheck(BST_CHECKED);
	pm_ExpDataTxt->SetCheck(BST_CHECKED);
	pm_ExpMsgTxt->SetCheck(BST_CHECKED);
	pm_ExpMsgSynthetic->SetCheck(BST_CHECKED);


	GetDlgItem(IDC_BUTTON1)->SetFocus(); // set focus on Open button

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTestLnKLibDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTestLnKLibDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTestLnKLibDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CTestLnKLibDlg::OnButton1() 
{
	int status;
	char buf[255];

	status = LnKSLIMbusOpen();

	if( status >= 0 )
	{

		sprintf( buf,"Open = %d", status );
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_ERROR_LAST))
		{
			sprintf( buf,"Open - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"Open - Error code %d [Unknown error]", status );
		}
	}


	m_log.SetWindowText(buf);
	m_log.UpdateWindow();
}

void CTestLnKLibDlg::OnClose() 
{
	int status;
	char buf[255];

	status = LnKSLIMbusClose();

	if( status >= 0 )
	{

		sprintf( buf,"Close = %d", status );
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_ERROR_LAST))
		{
			sprintf( buf,"Close - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"Close - Error code %d [Unknown error]", status );
		}
	}


	m_log.SetWindowText(buf);
	m_log.UpdateWindow();
	
}

void CTestLnKLibDlg::OnGetSwVersion() 
{
	int status;
	char buf[255];

	status = LnKSLIMbusGetSWVersion();

	if( status >= 0 )
	{

		sprintf( buf,"LnK SLIMbus Analyzer software version = %x.%02x", status/0x100, status%0x100, status );
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_ERROR_LAST))
		{
			sprintf( buf,"GetSWVersion - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"GetSWVersion - Error code %d [Unknown error]", status );
		}
	}

	m_log.SetWindowText(buf);
	m_log.UpdateWindow();
}


void CTestLnKLibDlg::OnGetDLLVersion() 
{
	int status;
	char buf[255];

	status = LnKSLIMbusGetDLLVersion();

	if( status >= 0 )
	{

		sprintf( buf,"DLL software version = %d.%02d", status/0x100, status%0x100 );
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_ERROR_LAST))
		{
			sprintf( buf,"GetDLLVersion - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"GetDLLVersion - Error code %d [Unknown error]", status );
		}
	}


	m_log.SetWindowText(buf);
	m_log.UpdateWindow();
}

void CTestLnKLibDlg::OnGetConfig() 
{
	int status;
	char buf[255];

	status = LnKSLIMbusGetConfig();

	if( status >= 0 )
	{

		sprintf( buf,"GetConfig = 0x%04x %s %s %s %s %s"
			, status 
			, (status & LNK_SLIMBUS_CONFIG_SLIMBUS) ? "SLIMbus" : ""
			, (status & LNK_SLIMBUS_CONFIG_SW_ANALYZER) ? "SW_ANALYZER" : ""
			, (status & LNK_SLIMBUS_CONFIG_SW_TG) ? "SW_TG" : ""
			, (status & LNK_SLIMBUS_CONFIG_HW_ANALYZER) ? "HW_ANALYZER" : ""
			, (status & LNK_SLIMBUS_CONFIG_HW_TG) ? "HW_TG" : ""
			);
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_ERROR_LAST))
		{
			sprintf( buf,"GetConfig - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"GetConfig - Error code %d [Unknown error]", status );
		}
	}


	m_log.SetWindowText(buf);
	m_log.UpdateWindow();
}

void CTestLnKLibDlg::OnGetSN() 
{
	int status;
	char buf[255];

	status = LnKSLIMbusGetSN();

	if( status >= 0 )
	{

		sprintf( buf,"License Key number = %d", status );
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_ERROR_LAST))
		{
			sprintf( buf,"GetSN - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"GetSN - Error code %d [Unknown error]", status );
		}
	}


	m_log.SetWindowText(buf);
	m_log.UpdateWindow();
}


void CTestLnKLibDlg::OnGetHWid() 
{
	int status;
	char buf[255];

	status = LnKSLIMbusGetHWid();

	if( status >= 0 )
	{

		sprintf( buf,"Hardware ID = 0x%x", status );
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_ERROR_LAST))
		{
			sprintf( buf,"GetHWid - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"GetHWid - Error code %d [Unknown error]", status );
		}
	}


	m_log.SetWindowText(buf);
	m_log.UpdateWindow();
}


void CTestLnKLibDlg::OnStartFullRec() 
{
	int status;
	char buf[255];

	status = LnKSLIMbusAnalyzerStartRecordFull();

	if( status >= 0 )
	{

		sprintf( buf,"Started FULL Recording" );
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_ERROR_LAST))
		{
			sprintf( buf,"StartRecordFull - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"StartRecordFull - Error code %d [Unknown error]", status );
		}
	}


	m_log.SetWindowText(buf);
	m_log.UpdateWindow();
}


void CTestLnKLibDlg::OnStopFullRec() 
{
	int status;
	char buf[255];

	status = LnKSLIMbusAnalyzerStopRecordFull();

	if( status >= 0 )
	{

		sprintf( buf,"Stopped FULL Recording" );
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_ERROR_LAST))
		{
			sprintf( buf,"StopRecordFull - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"StopRecordFull - Error code %d [Unknown error]", status );
		}
	}


	m_log.SetWindowText(buf);
	m_log.UpdateWindow();
}


void CTestLnKLibDlg::OnStartMsgRec() 
{
	int status;
	char buf[255];

	status = LnKSLIMbusAnalyzerStartRecordMessages();

	if( status >= 0 )
	{

		sprintf( buf,"Started MESSAGE Recording" );
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_ERROR_LAST))
		{
			sprintf( buf,"StartRecordMessages - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"StartRecordMessages - Error code %d [Unknown error]", status );
		}
	}


	m_log.SetWindowText(buf);
	m_log.UpdateWindow();
}


void CTestLnKLibDlg::OnStopMsgRec() 
{
	int status;
	char buf[255];

	status = LnKSLIMbusAnalyzerStopRecordMessages();

	if( status >= 0 )
	{

		sprintf( buf,"Stopped MESSAGE Recording" );
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_ERROR_LAST))
		{
			sprintf( buf,"StopRecordMessages - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"StopRecordMessages - Error code %d [Unknown error]", status );
		}
	}


	m_log.SetWindowText(buf);
	m_log.UpdateWindow();
}


void CTestLnKLibDlg::OnPollLiveMsgCntr() 
{
	int status;
	char buf[255];

	status = LnKSLIMbusAnalyzerPollLiveViewMessageCounter();

	if( status >= 0 )
	{

		sprintf( buf,"Polling Messages counter %d", status );
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_ERROR_LAST))
		{
			sprintf( buf,"Polling Messages counter - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"Polling Messages counter - Error code %d [Unknown error]", status );
		}
	}


	m_log.SetWindowText(buf);
	m_log.UpdateWindow();
	
}


void CTestLnKLibDlg::OnGetLiveMsg() 
{
	char message[255];
	int status;
	char buf[255];

	status = LnKSLIMbusAnalyzerGetLiveViewMessage( message );
	if( status >= 0 )
	{

		sprintf( buf,"GetLiveMsg" );
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_ERROR_LAST))
		{
			sprintf( buf,"GetLiveMsg - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"GetLiveMsg - Error code %d [Unknown error]", status );
		}
	}


	m_log.SetWindowText(buf);
	m_log.UpdateWindow();
}


void CTestLnKLibDlg::OnOpenSBA() 
{
	CString filename;
	int status;
	char buf[255];

	m_OpenSba.GetWindowText( filename );
	sprintf( buf, "%s", filename);

	status = LnKSLIMbusOpenSBA( buf );

	if( status >= 0 )
	{

		sprintf( buf,"Open SBA %s = %d", filename, status );
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_ERROR_LAST))
		{
			sprintf( buf,"OpenSBA - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"OpenSBA - Error code %d [Unknown error]", status );
		}
	}


	m_log.SetWindowText(buf);
	m_log.UpdateWindow();	
}


void CTestLnKLibDlg::OnSaveSBAas() 
{
	CString filename;
	int status;
	char buf[255];

	m_SaveAs.GetWindowText( filename );
	sprintf( buf, "%s", filename);

	status = LnKSLIMbusSaveAsSBA( buf );

	if( status >= 0 )
	{

		sprintf( buf,"SaveSBAas %s = %d", filename, status );
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_ERROR_LAST))
		{
			sprintf( buf,"SaveSBAas - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"SaveSBAas - Error code %d [Unknown error]", status );
		}
	}

	m_log.SetWindowText(buf);
	m_log.UpdateWindow();
}


void CTestLnKLibDlg::OnImportVCD() 
{
	char datalabel[255];
	char clocklabel[255];
	CString filename;
	CString Sdatalabel;
	CString Sclocklabel;
	int status;
	char buf[255];

	m_ImportVCD.GetWindowText( filename );
	sprintf( buf, "%s", filename);
	m_VCD_DataLabel.GetWindowText( Sdatalabel );
	m_VCD_ClockLabel.GetWindowText( Sclocklabel );
	sprintf( datalabel, "%s", Sdatalabel);
	sprintf( clocklabel, "%s", Sclocklabel);


	status = LnKSLIMbusImportVcd( buf, datalabel, clocklabel );

	if( status >= 0 )
	{

		sprintf( buf,"ImportVcd %s ckl (%s) data (%s) = %d", filename, datalabel, clocklabel, status );
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_ERROR_LAST))
		{
			sprintf( buf,"ImportVcd - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"ImportVcd - Error code %d [Unknown error]", status );
		}
	}


	m_log.SetWindowText(buf);
	m_log.UpdateWindow();
}


void CTestLnKLibDlg::OnExportRAW() 
{
	int		Format				= 0;
	int		From				= 0;
	int		To					= 0;
	bool	All					= true;
	bool	IncludeFrameInfo	= true;
	int		status;
	char	buf[255];
	char	fn[255];
	CString Str;



	if( pm_ExpRawAll->GetCheck() )
	{
		All = true;
	}
	else
	{
		All = false;
		m_EditRawTo.GetWindowText( Str );
		To = atoi( Str );
		m_EditRawFrom.GetWindowText( Str );
		From = atoi( Str );
	}

	if( pm_ExpRawTxt->GetCheck() )
	{
		Format = 0; // txt
	}
	else
	{
		Format = 1; // Html
	}

	if( m_exp_raw_incl_framing.GetCheck() )
	{
		IncludeFrameInfo = true; 
	}
	else
	{
		IncludeFrameInfo = false; 
	}



	m_RawFilename.GetWindowText( Str );
	sprintf( fn, "%s", Str);

	status = LnKSLIMbusExportRaw( Format, From, To, All, IncludeFrameInfo, fn );

	if( status >= 0 )
	{

		sprintf( buf,"ExportRaw format %d  from %d to %d, All %d IncludeFraming Info %d filename(%s) = %d"
			, Format
			, From
			, To
			, All
			, IncludeFrameInfo
			, fn
			, status );
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_ERROR_LAST))
		{
			sprintf( buf,"ExportRaw - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"ExportRaw - Error code %d [Unknown error]", status );
		}
	}

	m_log.SetWindowText(buf);
	m_log.UpdateWindow();
}


void CTestLnKLibDlg::OnExportData() 
{
	int		Channel				= 0;
	int		Format				= 0;
	int		From				= 0;
	int		To					= 0;
	bool	All					= true;
	bool	DataMode			= true;
	int		status;
	char	buf[255];
	char	fn[255];
	CString Str;
	CString filename;

	m_ExpDataChan.GetWindowText( Str );
	Channel =  atoi(Str);


	if( pm_ExpDataAll->GetCheck() )
	{
		All = true;
	}
	else
	{
		All = false;
		m_DataTo.GetWindowText( Str );
		To = atoi( Str );
		m_DataFrom.GetWindowText( Str );
		From = atoi( Str );
	}

	if( pm_ExpDataTxt->GetCheck() )
	{
		Format = 0; // txt
	}
	else
	{
		Format = 1; // Html
	}

	if( m_ExpDataRaw.GetCheck() )
	{
		DataMode = 0; 
	}
	else
	{
		DataMode = 1;
	}


	m_DataFilename.GetWindowText( filename );
	sprintf( fn, "%s", filename);

	status = LnKSLIMbusExportData( Channel, Format, From, To, All, fn ,DataMode );	


	if( status >= 0 )
	{
		sprintf( buf,"ExportData Channel %d  Format %d from %d to %d All %d filename(%s) DataMode %d = %d"
			, Channel
			, Format
			, From
			, To
			, All
			, fn
			, DataMode
			, status );
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_ERROR_LAST))
		{
			sprintf( buf,"ExportData - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"ExportData - Error code %d [Unknown error]", status );
		}
	}


	m_log.SetWindowText(buf);
	m_log.UpdateWindow();
}


void CTestLnKLibDlg::OnExportMsg() 
{
	int		Type				= 0;
	int		Format				= 0;
	int		From				= 0;
	int		To					= 0;
	bool	All					= true;
	bool	IncludeFrameInfo	= true;
	int		LogicalAddress		= 0;
	int		status;
	char	buf[255];
	char	fn[255];
	CString filename;
	CString Str;

	if( pm_ExpMsgAll->GetCheck() )
	{
		All = true;
	}
	else
	{
		All = false;
		m_MsgTo.GetWindowText( Str );
		To = atoi( Str );
		m_MsgFrom.GetWindowText( Str );
		From = atoi( Str );
	}

	if( pm_ExpMsgTxt->GetCheck() )
	{
		Format = 0; // txt
	}
	else
	{
		Format = 1; // Html
	}

	if( m_MsgFramingInfo.GetCheck() )
	{
		IncludeFrameInfo = true; 
	}
	else
	{
		IncludeFrameInfo = false; 
	}

	if( pm_ExpMsgRaw->GetCheck() )
	{
		Type = 0; // raw
		Format = 0; // txt
		pm_ExpMsgTxt->SetCheck(true);
		pm_ExpMsgHtml->SetCheck(false);
	}
	else if( pm_ExpMsgDetailed->GetCheck() )
	{
		Type = 1;
	}
	else if( pm_ExpMsgSynthetic->GetCheck() )
	{
		Type = 2; //synthetic
		Format = 1; // Html
		pm_ExpMsgTxt->SetCheck(false);
		pm_ExpMsgHtml->SetCheck(true);
	}
	else if( pm_ExpMsgCSV->GetCheck() )
	{
		Type = 3; //CSV
		Format = 0; // Html
		pm_ExpMsgTxt->SetCheck(true);
		pm_ExpMsgHtml->SetCheck(false);
		m_MsgLA.GetWindowText( Str );
		LogicalAddress = atoi( Str );

	}


	m_MsgFilename.GetWindowText( filename );
	sprintf( fn, "%s", filename);

	status = LnKSLIMbusExportMsg( Type, Format, From, To, All, IncludeFrameInfo, LogicalAddress, fn );	

	if( status >= 0 )
	{

		sprintf( buf,"ExportMsg Type %d  from %d to %d All %d IncludeFramingInfo %d LogicalAddress %d filename(%s) = %d"
			, Type
			, From
			, To
			, All
			, IncludeFrameInfo
			, LogicalAddress
			, fn
			, status );
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_ERROR_LAST))
		{
			sprintf( buf,"ExportMsg - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"ExportMsg - Error code %d [Unknown error]", status );
		}
	}


	m_log.SetWindowText(buf);
	m_log.UpdateWindow();
}


void CTestLnKLibDlg::OnLoadTG() 
{
	int		status;
	char	buf[255];
	char	fn[255];
	CString filename;

	m_LoadTG.GetWindowText( filename );
	sprintf( fn, "%s", filename);
	status = LnKSLIMbusTrafficGeneratorLoadTG( fn );	

	if( status >= 0 )
	{

		sprintf( buf,"TrafficGeneratorLoadTG filename(%s) = %d"
			, fn
			, status );
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_ERROR_LAST))
		{
			sprintf( buf,"TrafficGeneratorLoadTG - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"TrafficGeneratorLoadTG - Error code %d [Unknown error]", status );
		}
	}


	m_log.SetWindowText(buf);
	m_log.UpdateWindow();
}


void CTestLnKLibDlg::OnLoadXML() 
{
	CString filename;
	int		status;
	char	buf[255];


	m_LoadXML.GetWindowText( filename );
	sprintf( buf, "%s", filename);
	status = LnKSLIMbusTrafficGeneratorLoadXML(buf);
	if( status >= 0 )
	{

		sprintf( buf,"TrafficGeneratorLoadXML  filename(%s) = %d"
			, filename
			, status );
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_ERROR_LAST))
		{
			sprintf( buf,"TrafficGeneratorLoadXML - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"TrafficGeneratorLoadXML - Error code %d [Unknown error]", status );
		}
	}


	m_log.SetWindowText(buf);
	m_log.UpdateWindow();
}


void CTestLnKLibDlg::OnTGPlay() 
{
	int		status;
	char	buf[255];

	status = LnKSLIMbusTrafficGeneratorPlay();
	if( status >= 0 )
	{

		sprintf( buf,"TrafficGeneratorPlay = %d"
			, status );
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_ERROR_LAST))
		{
			sprintf( buf,"TrafficGeneratorPlay - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"TrafficGeneratorPlay - Error code %d [Unknown error]", status );
		}
	}


	m_log.SetWindowText(buf);
	m_log.UpdateWindow();
	
}


void CTestLnKLibDlg::OnTGStop() 
{
	int		status;
	char	buf[255];

	status = LnKSLIMbusTrafficGeneratorStop();
	if( status >= 0 )
	{

		sprintf( buf,"TrafficGeneratorStop = %d"
			, status );
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_ERROR_LAST))
		{
			sprintf( buf,"TrafficGeneratorStop - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"TrafficGeneratorStop - Error code %d [Unknown error]", status );
		}
	}


	m_log.SetWindowText(buf);
	m_log.UpdateWindow();
}


void CTestLnKLibDlg::OnIsConnected() 
{
	int				status;
	char			buf[255];

	status = LnKSLIMbusHWIsConnected();

	if( status == LNK_SLIMBUS_OK )
	{
		sprintf( buf,"HWIsConnected = true" );
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_ERROR_LAST))
		{
			sprintf( buf,"HWIsConnected - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"HWIsConnected - Error code %d [Unknown error]", status );
		}
	}


	m_log.SetWindowText(buf);
	m_log.UpdateWindow();
}


void CTestLnKLibDlg::OnHWConfig() 
{
	unsigned char	SBLevel = 12;
	unsigned char	IOLevel = 18;
	bool			BusHold = true;
	int				status;
	char			buf[255];



	switch( GetCheckedRadioButton(IDC_SB_33,IDC_SB_12) )
	{
		case IDC_SB_33:
			SBLevel = 33;
			break;

		case IDC_SB_18:
			SBLevel = 18;
			break;

		case IDC_SB_12:
			SBLevel = 12;
			break;

		default:
			SBLevel = 18;
			break;
	}

	switch( GetCheckedRadioButton(IDC_IO_33,IDC_IO_12) )
	{
		case IDC_IO_33:
			IOLevel = 33;
			break;

		case IDC_IO_18:
			IOLevel = 18;
			break;

		case IDC_IO_12:
			IOLevel = 12;
			break;

		default:
			IOLevel = 18;
			break;
	}


	if( m_BusHold.GetState())
	{
		BusHold = true;
	}
	else
	{
		BusHold = false;
	}

	status = LnKSLIMbusHWSetConfig( SBLevel, IOLevel, BusHold);

	if( status >= 0 )
	{

		sprintf( buf,"HWSetConfig SBlevel %d, IOlevel %d, BusHold %d = %d"
			, SBLevel
			, IOLevel
			, BusHold
			, status );
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_ERROR_LAST))
		{
			sprintf( buf,"HWSetConfig - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"HWSetConfig - Error code %d [Unknown error]", status );
		}
	}


	m_log.SetWindowText(buf);
	m_log.UpdateWindow();
}


void CTestLnKLibDlg::OnGetHWConfig() 
{
	int				status;
	char			buf[255];
	CButton		*	pcb;



	status = LnKSLIMbusHWGetConfig();

	if( status >= 0 )
	{
//						if > 0
//						- bits 0-7  SLIMBUS Data and Clock line voltage level: 12=1v2, 18=1v8, 33=3v3
//						- bits 8-15 Trigger I/O Voltage level: 12=1v2, 18=1v8, 33=3v3
//						- bit 16	SLIMBUS Data Bus Hold, 1 = active, 0 = inactive

		sprintf( buf,"HWGetConfig SBlevel %d, IOlevel %d, BusHold %d = %d"
			, status & 0xff
			, (status & 0xff00)>>8
			, (status & 0x10000) >>16
			, status );
		if( (status & 0x10000) >> 16 )
		{
			m_BusHold.SetCheck(true) ;
		}
		else
		{
			m_BusHold.SetCheck(false) ;
		}

		switch( status & 0xff )
		{
			case 12:
				pcb = (CButton * ) GetDlgItem(IDC_SB_12);
				pcb->SetCheck(true);
				pcb = (CButton * ) GetDlgItem(IDC_SB_18);
				pcb->SetCheck(false);
				pcb = (CButton * ) GetDlgItem(IDC_SB_33);
				pcb->SetCheck(false);
				break;

			case 18:
				pcb = (CButton * ) GetDlgItem(IDC_SB_12);
				pcb->SetCheck(false);
				pcb = (CButton * ) GetDlgItem(IDC_SB_18);
				pcb->SetCheck(true);
				pcb = (CButton * ) GetDlgItem(IDC_SB_33);
				pcb->SetCheck(false);
				break;

			case 33:
			default:
				pcb = (CButton * ) GetDlgItem(IDC_SB_12);
				pcb->SetCheck(false);
				pcb = (CButton * ) GetDlgItem(IDC_SB_18);
				pcb->SetCheck(false);
				pcb = (CButton * ) GetDlgItem(IDC_SB_33);
				pcb->SetCheck(true);
				break;
		}

		switch( (status & 0xff00)>>8 )
		{
			case 12:
				pcb = (CButton * ) GetDlgItem(IDC_IO_12);
				pcb->SetCheck(true);
				pcb = (CButton * ) GetDlgItem(IDC_IO_18);
				pcb->SetCheck(false);
				pcb = (CButton * ) GetDlgItem(IDC_IO_33);
				pcb->SetCheck(false);
				break;

			case 18:
				pcb = (CButton * ) GetDlgItem(IDC_IO_12);
				pcb->SetCheck(false);
				pcb = (CButton * ) GetDlgItem(IDC_IO_18);
				pcb->SetCheck(true);
				pcb = (CButton * ) GetDlgItem(IDC_IO_33);
				pcb->SetCheck(false);
				break;

			case 33:
			default:
				pcb = (CButton * ) GetDlgItem(IDC_IO_12);
				pcb->SetCheck(false);
				pcb = (CButton * ) GetDlgItem(IDC_IO_18);
				pcb->SetCheck(false);
				pcb = (CButton * ) GetDlgItem(IDC_IO_33);
				pcb->SetCheck(true);
				break;
		}




	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_ERROR_LAST))
		{
			sprintf( buf,"HWGetConfig - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"HWGetConfig - Error code %d [Unknown error]", status );
		}
	}


	m_log.SetWindowText(buf);
	m_log.UpdateWindow();
	UpdateWindow();

}


void CTestLnKLibDlg::OnGetBusState() 
{
	int				status;
	char			buf[255];

	status = LnKSLIMbusGetSLIMBusStatus();

	if( status >= 0 )
	{
//						- bits 0 - 3		RootFreq		4 bits
//						- bits 4 - 7		ClockGear		4 bits
//						- bits 8 - 12		SubFrameMode	5 bits
//						- bit  16			Current Clock activity on the bus	
//						- bit  17			Current Data activity on the bus	
//						- bit  18			Current Frame Sync state on the bus	
//						- bit  19			Current Super Frame Sync state on the bus	

		sprintf( buf,"GetSLIMBusStatus = 0x%x RF %d CG %d SFM %d %s %s %s %s"
			, status 
			, status & 0xf
			, (status & 0xf0)>>4
			, (status & 0x1f00)>>8
			, (status & 0x10000) ? "[CLK]" : ""
			, (status & 0x20000) ? "[DATA]" : ""
			, (status & 0x40000) ? "[FS]" : ""
			, (status & 0x80000) ? "[SFS]" : ""
			);
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_ERROR_LAST))
		{
			sprintf( buf,"GetSLIMBusStatus - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"GetSLIMBusStatus - Error code %d [Unknown error]", status );
		}
	}

	m_log.SetWindowText(buf);
	m_log.UpdateWindow();
}


void CTestLnKLibDlg::OnGetActionStatus() 
{
	int				status;
	char			buf[255];

	status = LnKSLIMbusGetActionStatus();

	if( status >= 0 )
	{
//						- LNK_SLIMBUS_IDLE
//						- LNK_SLIMBUS_FULL_RECORDING
//						- LNK_SLIMBUS_MESSAGE_RECORDING

		sprintf( buf,"GetActionStatus = %d  %s %s "
			, status 
			, (status & LNK_SLIMBUS_FULL_RECORDING) ? "FULL_RECORDING" : " "
			, (status & LNK_SLIMBUS_MESSAGE_RECORDING) ? "MESSAGE_RECORDING" : " "
			);
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_ERROR_LAST))
		{
			sprintf( buf,"GetActionStatus - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"GetActionStatus - Error code %d [Unknown error]", status );
		}
	}

	m_log.SetWindowText(buf);
	m_log.UpdateWindow();
}

void CTestLnKLibDlg::Ondebugjk() 
{
	char			buf[255];

	sprintf( buf,"GetState %d ", GetCheckedRadioButton(IDC_SB_33,IDC_SB_12) - IDC_SB_12 );

	m_log.SetWindowText(buf);
	m_log.UpdateWindow();
}

void CTestLnKLibDlg::OnButtonResetHw() 
{
	int				status;
	char			buf[255];

	status = LnKSLIMbusHWReset();

	if( status >= 0 )
	{
//						- LNK_SLIMBUS_IDLE

		sprintf( buf,"Reset Hardware"
			);
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_ERROR_LAST))
		{
			sprintf( buf,"Reset Hardware - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"Reset Hardware - Error code %d [Unknown error]", status );
		}
	}

	m_log.SetWindowText(buf);
	m_log.UpdateWindow();
	
}



void CTestLnKLibDlg::OnBnClickedButtonGetNrDataCh() 
{
	int		status;
	char	buf[256];
	unsigned char	ActiveDataChannels[256];

	status = LnKSLIMbusReportAllActiveDataChannels(ActiveDataChannels);

	sprintf( buf, "nr= %3d   ", status );
	if((status > 0 ) && (status < 256 ))
	{
		for( int a = 0; a < status; a++ )
		{
			sprintf( buf + 8 + (5*a),"%3d,  ", ActiveDataChannels[a] );
		}
	}
 
	m_log.SetWindowText(buf);
	m_log.UpdateWindow();

	
}

void CTestLnKLibDlg::OnBnClickedButtonExportAllDataHistory() 
{
	int		status;
	char	buf[256];

	status = LnKSLIMbusGetAllDataChannelsHistory2CSV( "c:\\sba\\AllDataHistory.txt");
	if( status >= 0 )
	{
		sprintf( buf,"ExportAllDataHistory done"
			);
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_ERROR_LAST))
		{
			sprintf( buf,"ExportAllDataHistory - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"ExportAllDataHistory - Error code %d [Unknown error]", status );
		}
	}

 
	m_log.SetWindowText(buf);
	m_log.UpdateWindow();

	
}

void CTestLnKLibDlg::OnBnClickedButtonExportDataHistory() 
{
	int		status;
	char	buf[256];
	int channel = 1;
	CString			Str;

	m_ExportDataCh.GetWindowText( Str );

	channel = atoi(Str);

	status = LnKSLIMbusGetDataChannelHistory2CSV( channel,"c:\\sba\\DataHistory.txt");
	if( status >= 0 )
	{
		sprintf( buf,"ExportAllDataHistory channel %d done", channel);
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_ERROR_LAST))
		{
			sprintf( buf,"ExportDataHistory - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"ExportDataHistory - Error code %d [Unknown error]", status );
		}
	}

 
	m_log.SetWindowText(buf);
	m_log.UpdateWindow();

	
}

void CTestLnKLibDlg::OnBnClickedButtonGetAllDataHistory() 
{
	int				status;
	char			buf[256];
	DATA_REPORT_HDR drh;


	status = LnKSLIMbusGetAllDataChannelsHistory();
	if( status >= 0 )
	{
		sprintf( buf,"GetAllDataChannelsHistory  done" );

		while( LnKSLIMbusRetrieveDataChannelHistory( &drh) == LNK_SLIMBUS_OK )
		{

			sprintf( buf,"idx: %d  ch: %3d SF: %4d  - Off: %d Len: %d Interval: %d Presence Rate %d Hz"
					, drh.idx
					, drh.ch
					, drh.sf

//					DRH.Timestamp_ms
//					DRH.Timestamp_ns

//					DRH.RootFreq
//					DRH.ClockGear

//					DRH.Inited
//					DRH.Enabled
//					DRH.Protocol

					, drh.Offset
					, drh.Length
					, drh.Interval
//					DRH.SegDist

//					DRH.FreqLock
					, drh.PresenceRate
//					DRH.AuxBitFormat
//					DRH.DataType
//					DRH.ChannelLink
//					DRH.DataLength
//					DRH.TagLen
					);

			m_log.SetWindowText(buf);
			m_log.UpdateWindow();
			::Sleep(1000);
		}



	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_ERROR_LAST))
		{
			sprintf( buf,"GetAllDataChannelsHistory  - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"GetAllDataChannelsHistory  - Error code %d [Unknown error]", status );
		}
		m_log.SetWindowText(buf);
		m_log.UpdateWindow();
	}

}

void CTestLnKLibDlg::OnBnClickedButtonGetDataHistory() 
{
	int				status;
	char			buf[256];
	int				channel = 1;
	DATA_REPORT_HDR drh;
	CString			Str;

	m_GetDataCh.GetWindowText( Str );

	channel = atoi(Str);

	status = LnKSLIMbusGetDataChannelHistory(channel);
	if( status >= 0 )
	{
		sprintf( buf,"GetDataChannelHistory  done" );

		while( LnKSLIMbusRetrieveDataChannelHistory( &drh) == LNK_SLIMBUS_OK )
		{

			sprintf( buf,"idx: %d  ch: %3d SF: %4d  - Off: %d Len: %d Interval: %d Presence Rate %d Hz"
					, drh.idx
					, drh.ch
					, drh.sf

//					DRH.Timestamp_ms
//					DRH.Timestamp_ns

//					DRH.RootFreq
//					DRH.ClockGear

//					DRH.Inited
//					DRH.Enabled
//					DRH.Protocol

					, drh.Offset
					, drh.Length
					, drh.Interval
//					DRH.SegDist

//					DRH.FreqLock
					, drh.PresenceRate
//					DRH.AuxBitFormat
//					DRH.DataType
//					DRH.ChannelLink
//					DRH.DataLength
//					DRH.TagLen
					);

			m_log.SetWindowText(buf);
			m_log.UpdateWindow();
			::Sleep(1000);
		}



	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_ERROR_LAST))
		{
			sprintf( buf,"GetDataChannelHistory  - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"GetDataChannelHistory  - Error code %d [Unknown error]", status );
		}
		m_log.SetWindowText(buf);
		m_log.UpdateWindow();
	}

}



